<?php

include "libchart/classes/libchart.php";
	
$router = $_GET["router"];
$ip = $_GET["ip"];
$machine = $_GET["name"];

$searchDayDn = 'download,hour,24,'.$ip;
$searchDayUp = 'upload,hour,24,'.$ip;
$searchHourDn = 'download,minute,15,'.$ip;
$searchHourUp = 'upload,minute,15,'.$ip;
$searchMonthDn = 'download,day,31,'.$ip;
$searchMonthUp = 'upload,day,31,'.$ip;
$searchYearDn = 'download,month,12,'.$ip;
$searchYearUp = 'upload,month,12,'.$ip;


$header = <<<HEAD
<html>
<head>
<link rel="stylesheet" type="text/css" href="usage.css">
</head>
<body>
HEAD;

$footer = <<<FOOT
<img alt="Line chart" src="generated/Hour.png" style="border: 1px solid gray;"/>
<br>
<img alt="Line chart" src="generated/Day.png" style="border: 1px solid gray;"/>
<br>
<img alt="Line chart" src="generated/Month.png" style="border: 1px solid gray;"/>
<br>
<img alt="Line chart" src="generated/Year.png" style="border: 1px solid gray;"/>
<br>
</body>
</html>
FOOT;

print $header;	


//set the Gargoyle router configuration here
$router = 'http://'.$router; //Location of the Router webinterface
$pass = 'password'; //Router login password
$file = 'bandwidth.csv';

//grabs a file from the router using the PHP CURL library
$data="password=$pass";
$ch = curl_init();
//first use CURL to get the login cookie
curl_setopt($ch, CURLOPT_URL, $router."/utility/get_password_cookie.sh");
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$header = curl_exec ($ch);
//extract cookie string from header. Cookie starts at first "Set-Cookie" ocurrence
$p = strpos($header,'Set-Cookie');
//copy string from "Set-Cookie" to end of string
$cookie=substr($header,$p+11,strlen($header));
//remove unwanted stuff from cookie
$cookie = str_replace('Set-Cookie:','',$cookie);
$cookie = str_replace('Path=/;',' ',$cookie);
$cookie = str_replace(';','',$cookie);
$cookie = str_replace(' ','',$cookie);
//get the cookie information (hash and exp)
$hashStart = strpos($cookie,'hash=');
$expireDateStart = strpos($cookie,'exp=');
$hash = substr($cookie,$hashStart,69);//64 character hex plus 5 characters for 'hash=' string
$expire = substr($cookie,$expireDateStart,14);//Length of plus 4 characters for 'exp=' string
//join the cookie information in a valid cookie string for CURLOPT_COOKIE parameter.
$cookie = $hash.'; '.$expire;
//Grab the requested file from the router
curl_setopt($ch, CURLOPT_URL, $router."/".$file);
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, false);
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$html = curl_exec($ch);
curl_close($ch);

//verify if the resulting html is valid by checking if some part of the html in the login form exists.
if (strpos($html, "id='password_label'") === FALSE) {
	//login OK, the output should be the CSV so let's convert the output to an array (each line of the CSV is one element)
	$html=nl2br($html);
	$lines = explode('<br />',$html);
} 



///////////////////////////
//
//    60 minutes
//
//establish new chart plugin
$chartHour = new LineChart();
$chartHour->getPlot()->getPalette()->setLineColor(array(
		new Color(255, 0, 0),
		new Color(64, 64, 255)));

//establish datasets
$dataSetHourDn = new XYDataSet();
$dataSetHourUp = new XYDataSet();

//find Hour download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchHourDn) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('i', $temp[$key][4]);
		$download = $temp[$key][6]/1024/1024;
		$dataSetHourDn->addPoint(new Point($date, $download));
	}
}

//find  Hour upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchHourUp) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('i', $temp[$key][4]);
		$upload = $temp[$key][6]/1024/1024;
		$dataSetHourUp->addPoint(new Point($date, $upload));
	}
}

//Link data sets
$dataSetHour = new XYSeriesDataSet();
$dataSetHour->addSerie("Dn", $dataSetHourDn);
$dataSetHour->addSerie("Up", $dataSetHourUp);
$chartHour->setDataSet($dataSetHour);
$chartHour->setTitle("15 minutes - ".$machine);
$chartHour->render("generated/Hour.png");







///////////////////////////
//
//    24 Hours
//
//establish new chart plugin
$chartDay = new LineChart();
$chartDay->getPlot()->getPalette()->setLineColor(array(
		new Color(255, 0, 0),
		new Color(64, 64, 255)));

//establish datasets
$dataSetDayDn = new XYDataSet();
$dataSetDayUp = new XYDataSet();

//find Day download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchDayDn) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('g a', $temp[$key][4]);
		$download = $temp[$key][6]/1024/1024;
		$dataSetDayDn->addPoint(new Point($date, $download));
	}
}

//find  Day upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchDayUp) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('g a', $temp[$key][4]);
		$upload = $temp[$key][6]/1024/1024;
		$dataSetDayUp->addPoint(new Point($date, $upload));
	}
}

//Link data sets
$dataSetDay = new XYSeriesDataSet();
$dataSetDay->addSerie("Dn", $dataSetDayDn);
$dataSetDay->addSerie("Up", $dataSetDayUp);
$chartDay->setDataSet($dataSetDay);
$chartDay->setTitle("1 Day - ".$machine);
$chartDay->render("generated/Day.png");





///////////////////////////
//
//   31 Days
//
//establish new chart plugin
$chartMonth = new LineChart();
$chartMonth->getPlot()->getPalette()->setLineColor(array(
		new Color(255, 0, 0),
		new Color(64, 64, 255)));

//establish datasets
$dataSetMonthDn = new XYDataSet();
$dataSetMonthUp = new XYDataSet();

//find monthly download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchMonthDn) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('n/d', $temp[$key][4]);
		$download = $temp[$key][6]/1024/1024;
		$dataSetMonthDn->addPoint(new Point($date, $download));
	}
}

//find monthly upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchMonthUp) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('n/d', $temp[$key][4]);
		$upload = $temp[$key][6]/1024/1024;
		$dataSetMonthUp->addPoint(new Point($date, $upload));
	}
}

//Link data sets
$dataSetMonth = new XYSeriesDataSet();
$dataSetMonth->addSerie("Dn", $dataSetMonthDn);
$dataSetMonth->addSerie("Up", $dataSetMonthUp);
$chartMonth->setDataSet($dataSetMonth);
$chartMonth->setTitle("1 Month - ".$machine);
$chartMonth->render("generated/Month.png");





///////////////////////////
//
//   12 Months
//
//establish new chart plugin
$chartYear = new LineChart();
$chartYear->getPlot()->getPalette()->setLineColor(array(
		new Color(255, 0, 0),
		new Color(64, 64, 255)));

//establish datasets
$dataSetYearDn = new XYDataSet();
$dataSetYearUp = new XYDataSet();

//find Yearly download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchYearDn) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('M', $temp[$key][4]);
		$download = $temp[$key][6]/1024/1024;
		$dataSetYearDn->addPoint(new Point($date, $download));
	}
}

//find Yearly upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, $searchYearUp) > 0) {
		$temp[$key] = explode(",", $value);
		$date = date('M', $temp[$key][4]);
		$upload = $temp[$key][6]/1024/1024;
		$dataSetYearUp->addPoint(new Point($date, $upload));
	}
}

//Link data sets
$dataSetYear = new XYSeriesDataSet();
$dataSetYear->addSerie("Dn", $dataSetYearDn);
$dataSetYear->addSerie("Up", $dataSetYearUp);
$chartYear->setDataSet($dataSetYear);
$chartYear->setTitle("1 Year - ".$machine);
$chartYear->render("generated/Year.png");









print $footer;

?>

